package com.example.switchupdate;

import java.util.ArrayList;

import com.example.switchupdate.client.switchcomp.SwitchCompClientRpc;
import com.example.switchupdate.client.switchcomp.SwitchCompServerRpc;

public class SwitchComp extends com.vaadin.ui.AbstractComponent {
	private static final long serialVersionUID = 1L;
	private boolean on;
	
	public boolean isOn() {
		return on;
	}

	public void setOn(boolean on) {
		this.on = on;
		getRpcProxy(SwitchCompClientRpc.class).setVal(on);
	}
	
	public void switchState(){
		on = !on;
		getRpcProxy(SwitchCompClientRpc.class).setVal(on);
	}

	private SwitchCompServerRpc rpc = new SwitchCompServerRpc() {
		private static final long serialVersionUID = 1L;

		@Override
		public void valueChanged(boolean newval) {
			on = newval;
			fireOnChange(newval);
		}
	};  

	public SwitchComp() {
		registerRpc(rpc);
		getRpcProxy(SwitchCompClientRpc.class).initState();
	}
	
	
	 ArrayList<OnChangeListener> listarr = new ArrayList<OnChangeListener>();
	    public void addOnChangeListener(OnChangeListener ocl) {
	    	listarr.add(ocl);
		}
	    
	    public void removeOnChangeListener(OnChangeListener ocl){
	    	listarr.remove(ocl);
	    }
	    
	    public void fireOnChange(boolean newval){
	    	for (int i = 0; i < listarr.size(); i++) {
	    		OnChangeListener ocl = listarr.get(i);
				ocl.valchange(newval);
			}
	    }
	    
	    public interface OnChangeListener{
	    	public void valchange(boolean newval);
		};
}
