package com.example.switchupdate;

import javax.servlet.annotation.WebServlet;

import com.example.switchupdate.SwitchComp.OnChangeListener;
import com.vaadin.annotations.Theme;
import com.vaadin.annotations.VaadinServletConfiguration;
import com.vaadin.server.VaadinRequest;
import com.vaadin.server.VaadinServlet;
import com.vaadin.ui.Button;
import com.vaadin.ui.Button.ClickEvent;
import com.vaadin.ui.Button.ClickListener;
import com.vaadin.ui.Label;
import com.vaadin.ui.UI;
import com.vaadin.ui.VerticalLayout;

@SuppressWarnings("serial")
@Theme("switchupdate")
public class SwitchupdateUI extends UI {

	@WebServlet(value = "/*", asyncSupported = true)
	@VaadinServletConfiguration(productionMode = false, ui = SwitchupdateUI.class, widgetset = "com.example.switchupdate.SwitchupdateWidgetset")
	public static class Servlet extends VaadinServlet {
	}

	SwitchComp sw;
	@Override
	protected void init(VaadinRequest request) {
		final VerticalLayout layout = new VerticalLayout();
		layout.setMargin(true);
		setContent(layout);

		sw = new SwitchComp();
		layout.addComponent(sw);
		
		Button btn = new Button();
		btn.addClickListener(new ClickListener() {
			
			@Override
			public void buttonClick(ClickEvent event) {
				sw.switchState();
			}
		});
		layout.addComponent(btn);
		
		sw.addOnChangeListener(new OnChangeListener() {
			
			@Override
			public void valchange(boolean newval) {
				layout.addComponent(new Label("On State changed to: "+newval));
			}
		});
	}

}