package com.example.switchupdate.client.switchcomp;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.ui.Widget;

import com.vaadin.client.ui.AbstractComponentConnector;
import com.vaadin.shared.ui.Connect;

import com.example.switchupdate.SwitchComp;
import com.example.switchupdate.client.switchcomp.SwitchCompWidget;
import com.example.switchupdate.client.switchcomp.SwitchCompServerRpc;
import com.example.switchupdate.client.switchcomp.SwitchCompWidget.ValChangeListener;
import com.vaadin.client.communication.RpcProxy;
import com.example.switchupdate.client.switchcomp.SwitchCompClientRpc;

@Connect(SwitchComp.class)
public class SwitchCompConnector extends AbstractComponentConnector {
	private static final long serialVersionUID = 1L;
	
	SwitchCompServerRpc rpc = RpcProxy
			.create(SwitchCompServerRpc.class, this);
	
	public SwitchCompConnector() {
		registerRpc(SwitchCompClientRpc.class, new SwitchCompClientRpc() {
			private static final long serialVersionUID = 1L;

			@Override
			public void initState() {
				getWidget().initState();
			}

			@Override
			public void setVal(boolean newval) {
				getWidget().setValue(newval, null);
			}
		});
		
		getWidget().addValChangeListener(new ValChangeListener() {
			
			@Override
			public void valchange(boolean newval) {
				rpc.valueChanged(newval);
			}
		});
//		// TODO ServerRpc usage example, do something useful instead
//		getWidget().addClickHandler(new ClickHandler() {
//			public void onClick(ClickEvent event) {
//				final MouseEventDetails mouseDetails = MouseEventDetailsBuilder
//					.buildMouseEventDetails(event.getNativeEvent(),
//								getWidget().getElement());
//				rpc.clicked(mouseDetails);
//			}
//		});

	}

	@Override
	protected Widget createWidget() {
		return GWT.create(SwitchCompWidget.class);
	}

	@Override
	public SwitchCompWidget getWidget() {
		return (SwitchCompWidget) super.getWidget();
	}

}

